import _regeneratorRuntime from "@babel/runtime/regenerator";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
var DETECTION_DELAY = 5000;
var __HANDLERS__ = {};

var waitUntil = function waitUntil(truthyFn, callback, delay, interval) {
  if (delay === void 0) {
    delay = 100;
  }

  if (interval === void 0) {
    interval = 100;
  }

  var intervalId = setInterval(function () {
    var value = truthyFn();

    if (value || delay <= 0) {
      clearInterval(intervalId);
      callback(value);
    }

    delay -= interval;
  }, interval);
};

var getTarget = function getTarget() {
  return window && window.adobe && window.adobe.target;
};

var getSDK = function getSDK() {
  return new Promise(function (resolve) {
    waitUntil(getTarget, function (sdk) {
      resolve(sdk);
    }, DETECTION_DELAY);
  });
};

export var addActivationListener =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee(experimentId, activationHandler) {
    var _objectSpread2;

    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            __HANDLERS__ = _objectSpread({}, __HANDLERS__, (_objectSpread2 = {}, _objectSpread2[experimentId] = [].concat(__HANDLERS__[experimentId], [activationHandler]), _objectSpread2));
            _context.next = 3;
            return getSDK();

          case 3:
            __HANDLERS__[window.sCampId] && __HANDLERS__[window.sCampId].forEach(function (handler) {
              console.log("Target experiement(" + window.sCampId + "): call handler for variant =>" + window.sExpId);
              handler(window.sExpId);
            });

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function addActivationListener(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();
export var removeActivationListener = function removeActivationListener(experimentId, handler) {
  var experiment = __HANDLERS__[experimentId];

  if (!experiment) {
    return null;
  }

  __HANDLERS__[experimentId] = experiment.filter(function (fn) {
    return fn !== handler;
  });
};